SvelteKit Template
------------------

This is a template for a SvelteKit project, and includes the following:

- **SvelteKit**
- **TailwindCSS**

  The Tailwind config contains the Rijkshuisstijl colors and typography.

  .. danger::

      The Rijkshuisstijl fonts are subject to a license.
      You may not use them if you are not a part of the Dutch government.

- **TypeScript**

  TypeScript is included and uses ts-reset for stricter types.
  TypeDoc is used for documentation and the generated documentation
  can be found in StoryBook.

- **ESLint**
- **Prettier**
- **Vitest**
- **StoryBook**

  StoryBook contains both the component documentation as well as
  the TypeDoc documentation (in a separate TypeDoc section).

Version information
"""""""""""""""""""

**Current Svelte version**: 4

.. note::

   This template will soon be updated to use Svelte 5.0.0

Project structure
"""""""""""""""""
The file structure of a SvelteKit project looks like:

.. code-block:: bash

    path/to/project/
    ├── CHANGELOG.rst
    ├── CONTRIBUTING.rst
    ├── Dockerfile
    ├── LICENSE
    ├── NOTICE
    ├── README.md
    ├── e2e # E2E testing files
    ├── mime.types
    ├── nginx.conf
    ├── package.json
    ├── playwright.config.ts # E2E testing configuration
    ├── postcss.config.cjs
    ├── src
    │   ├── app.css
    │   ├── app.d.ts
    │   ├── app.html
    │   ├── lib # TypeScript files and their tests
    │   │   ├── example.test.ts
    │   │   └── example.ts
    │   ├── reset.d.ts
    │   ├── routes
    │   │   ├── +layout.svelte
    │   │   ├── +layout.ts
    │   │   └── +page.svelte
    │   ├── stories
    │   │   ├── Components # Components and their documentation
    │   │   │   └── Example
    │   │   │       ├── Example.svelte
    │   │   │       └── Example.stories.svelte
    │   │   ├── Resources # MDX Documentation for the project (NOT component documentation)
    │   │   └── assets # Assets for storybook
    │   └── types # Globally used TypeScript types
    ├── static # Static files
    ├── svelte.config.js # Framework configuration
    ├── tailwind.config.cjs # Styling configuration
    ├── tsconfig.json # Build configuration
    ├── vite.config.ts # Build configuration
    └── vitest.config.ts # Unit testing configuration

* Code (existing or new) should be placed in the ``path/to/project/src`` folder
* Add documentation (textual as well as component documentation) by creating MDX files in ``path/to/project/src/stories``
* Tests go in the ``path/to/project/tests/`` directory

.. include:: ../../../README.rst
    :start-after: .. begin-inclusion-usage-marker-do-not-remove
    :end-before: .. end-inclusion-usage-marker-do-not-remove


Step 3: Generate the files and directory structure
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

To generate the files and directory structure for your new project run the following command:

.. code-block:: bash

    cookiecutter https://gitlab.com/rwsdatalab/public/templates/rws-datalab-templates --directory templates/svelte

Step 4: Make a new SvelteKit project
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

Fill in the form generated by the Cookiecutter template. You will be asked to supply the following information:

.. list-table::
   :header-rows: 1

   * - Name
     - Default value
     - Explanation
   * - project_name
     - python
     - Full project name. The package and distribution names are automatically derived from this. Ensure it starts with an alphabetical character and consists entirely of numbers, letters & spaces.
   * - project_short_description
     -
     - The information that you enter here will end up in the README, documentation, license, and pyproject.toml, so it may be a good idea to prepare something in advance
   * - version
     - 0.1.0
     - Package version
   * - gitlab_group (**required**)
     -
     - Gitlab repo path in the codebase. example: rwsdatalab/codebase/utils, required in the Svelte template for correctly linking documentation sources to Gitlab
   * - license
     - Not open source
     - The software license under which the code is made available
   * - author
     - RWS Datalab
     - Author of the software
   * - email
     - datalab.codebase@rws.nl
     - Contact email address
   * - copyright_holder
     - Rijkswaterstaat
     - Name(s) of the organization(s) or person(s) who hold the copyright of the software


In addition to the above properties, this Cookiecutter template also automatically generates *__project_slug* & *__package_name* properties for you. *__project_slug* represents the name of your package on GitLab and NPM (which both use "-" for spaces).

See below an example of the dialog of the Svelte template (note that if you press enter the default option as shown in between brackets is used).

.. code-block:: bash

    $ cookiecutter https://gitlab.com/rwsdatalab/public/templates/rws-datalab-templates --directory templates/svelte
    #
    #   [1/8] project_name (Projectnaam): sveltekit
    #   [2/8] project_short_description (Schrijf hier een korte beschrijving van je project):
    #   [3/8] version (0.1.0):
    #   [4/8] gitlab_group (): rwsdatalab/codebase/utils
    #   [5/8] Select license
    #     1 - Not open source
    #     2 - Apache Software License 2.0
    #     3 - MIT license
    #     4 - BSD license
    #     5 - ISC license
    #     6 - GNU General Public License v3 or later
    #     Choose from [1/2/3/4/5/6] (1):
    #   [6/8] author (RWS Datalab):
    #   [7/8] email (datalab.codebase@rws.nl):
    #   [8/8] copyright_holder (Rijkswaterstaat):
    #
    # To finish setting up your project:
    #
    # - Navigate to your project directory.
    # - Initialize a Git repository.
    # - Install the required development packages.
    # - Create your Git branches.
    # - Add all your files to the Git repository.
    # - Perform an initial commit.
    #
    # You could then proceed to add a remote and push it.
    # For example (you can directly copy these instructions):
    #
    # cd sveltekit
    # git init
    # npm i
    # git checkout -b main
    # git add .
    # git commit -m "Initial commit" --no-verify
    #
    $ cd sveltekit
    $ ls
    # CHANGELOG.rst     NOTICE      nginx.conf            src                  tests
    # CONTRIBUTING.rst  README.md   package.json          static               tsconfig.json
    # Dockerfile        e2e         playwright.config.ts  svelte.config.js     vite.config.ts
    # LICENSE           mime.types  postcss.config.cjs    tailwind.config.cjs  vitest.config.ts

Step 5: Initialize the Gitlab repository
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

Unversioned code is out-of-control code: `Get your code under version control! <https://rwsdatalab.gitlab.io/guides/werkwijze/ontwikkelgids/algemeen/version_control.html>`_.


Step 6 (Python): Install the dependencies
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

Now that the repository is initialized, you need to install the required dependencies.

.. code-block:: bash

    npm install

Next steps
""""""""""

* **Great! You've successfully created an empty project according to RWS Datalab standards.**


Other information (internal links):

* `Software development guide <https://rwsdatalab.gitlab.io/guides/werkwijze/ontwikkelgids/index.html>`_
